Unit ef13r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, EFFR_p, EFRS_p, EFUS_p, EFUF_p, EFSL_p, EFUD_p, EFRD_p;

procedure ef13r(var SX :Array of Real; var SY :Array of Real; N :Integer;
                M :Integer; var A :Array of Real; var U :Array of Real;
                var F :Array of Real; var P :Array of Real; P1 :Real;
                P2 :Real; P3 :Real; Q :Real; var H :Array of Real;
                var W :Array of Real; L :Integer);

implementation

procedure ef13r(var SX :Array of Real; var SY :Array of Real; N :Integer;
                M :Integer; var A :Array of Real; var U :Array of Real;
                var F :Array of Real; var P :Array of Real; P1 :Real;
                P2 :Real; P3 :Real; Q :Real; var H :Array of Real;
                var W :Array of Real; L :Integer);
var
I :Integer;
S1,S2 :Real;
const
ZERO :Real = 0.0;
IDATE :Integer = 130183;
label
_11,_12,_13,_14,_15,_19;
begin
case L of
 1: goto _11;
 2: goto _15;
 3: goto _15;
 4: goto _13;
end;
_11:
for I:=1 to 48 do
 begin
_12:
  H[I-1] := ZERO;
 end;
H[48] := (IDATE);
H[49] := 13.0;
EFFR(A,M,N,P,SX,SY,F,P1,P2,P3,W[0+0*N],W[0+1*N],W[0+2*N],H);
EFRS(A,M,N,W[0+0*N],W[0+1*N],W[0+2*N],H);
EFUS(A,M,N,W[0+3*N],W[0+4*N],H);
EFUF(A,M,N,F,H);
goto _19;
_13:
S1 := ZERO;
S2 := ZERO;
for I:=1 to M do
 begin
  F[I-1] := F[I-1]*P[I-1];
  S1 := S1+F[I-1]*P[I-1];
  S2 := S2+F[I-1]*F[I-1];
_14:
 end;
H[36] := S1/H[38];
H[37] := Sqrt(S2-S1*H[36]);
EFUF(A,M,N,F,H);
goto _19;
_15:
EFSL(W[0+3*N],W[0+4*N],M,N,Q,F,U,H,W[0+5*N],W[0+6*N],W[0+7*N]);
if ( L = 3 ) 
 then goto _19;
EFUD(A,M,N,U,H);
EFRD(U,N,W[0+0*N],W[0+1*N],W[0+2*N],SX,H);
_19:
end;

end.
